Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 2620)
@@ -19,9 +19,11 @@
    USE par_ice_2        ! LIM-2 parameters
 # endif
+   USE lib_mpp          ! MPP library
+   USE in_out_manager   ! I/O manager
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC sbc_ice_alloc ! called in nemogcm.F90
+   PUBLIC sbc_ice_alloc ! called in iceini(_2).F90
 
 # if defined  key_lim2
@@ -48,9 +50,9 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   alb_ice   !: albedo of ice
 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   utau_ice    !: atmos-ice u-stress. VP: I-pt ; EVP: U,V-pts   [N/m2]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   vtau_ice    !: atmos-ice v-stress. VP: I-pt ; EVP: U,V-pts   [N/m2]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fr1_i0      !: 1st Qsr fraction penetrating inside ice cover    [-]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fr2_i0      !: 2nd Qsr fraction penetrating inside ice cover    [-]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   emp_ice     !: sublimation-snow budget over ice             [kg/m2]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   utau_ice  !: atmos-ice u-stress. VP: I-pt ; EVP: U,V-pts   [N/m2]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   vtau_ice  !: atmos-ice v-stress. VP: I-pt ; EVP: U,V-pts   [N/m2]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   fr1_i0    !: 1st Qsr fraction penetrating inside ice cover    [-]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   fr2_i0    !: 2nd Qsr fraction penetrating inside ice cover    [-]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   emp_ice   !: sublimation-snow budget over ice             [kg/m2]
 
 # if defined key_lim3
@@ -65,13 +67,8 @@
 CONTAINS
 
-   FUNCTION sbc_ice_alloc()
+   INTEGER FUNCTION sbc_ice_alloc()
       !!----------------------------------------------------------------------
-     !!                     ***  FUNCTION sbc_ice_alloc  ***
-     !!
-     !! ** Purpose :   Allocate all the dynamic arrays in the modules
+      !!                     ***  FUNCTION sbc_ice_alloc  ***
       !!----------------------------------------------------------------------
-      INTEGER :: sbc_ice_alloc   ! return value
-      !!----------------------------------------------------------------------
-      !
       ALLOCATE( qns_ice (jpi,jpj,jpl) , qsr_ice (jpi,jpj,jpl) ,     &
          &      qla_ice (jpi,jpj,jpl) , dqla_ice(jpi,jpj,jpl) ,     &
@@ -80,7 +77,9 @@
          &      utau_ice(jpi,jpj)     , vtau_ice(jpi,jpj)     ,     &
          &      fr1_i0  (jpi,jpj)     , fr2_i0  (jpi,jpj)     ,     &
-         &      emp_ice(jpi,jpj)                              , STAT=sbc_ice_alloc)
-      !
-  END FUNCTION sbc_ice_alloc
+         &      emp_ice(jpi,jpj)                              , STAT=sbc_ice_alloc )
+         !
+      IF( lk_mpp            )   CALL mpp_sum ( sbc_ice_alloc )
+      IF( sbc_ice_alloc > 0 )   CALL ctl_warn('sbc_ice_alloc: allocation of arrays failed')
+   END FUNCTION sbc_ice_alloc
 
 #else
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 2620)
@@ -10,15 +10,23 @@
    !!            3.3  ! 2010-10  (J. Chanut, C. Bricaud)  add the surface pressure forcing
    !!----------------------------------------------------------------------
-   USE par_oce          ! ocean parameters
+
+   !!----------------------------------------------------------------------
+   !!   sbc_oce_alloc : allocation of sbc arrays
+   !!   sbc_tau2wnd   : wind speed estimated from wind stress
+   !!----------------------------------------------------------------------
+   USE par_oce        ! ocean parameters
+   USE in_out_manager ! I/O manager
+   USE lib_mpp        ! MPP library
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC sbc_oce_alloc ! routine called in nemogcm.F90
-
+   PUBLIC   sbc_oce_alloc   ! routine called in sbcmod.F90
+   PUBLIC   sbc_tau2wnd     ! routine called in several sbc modules
+   
    !!----------------------------------------------------------------------
    !!           Namelist for the Ocean Surface Boundary Condition
    !!----------------------------------------------------------------------
-   !                                             !! * namsbc namelist *
+   !                                            !!* namsbc namelist *
    LOGICAL , PUBLIC ::   ln_ana      = .FALSE.   !: analytical boundary condition flag
    LOGICAL , PUBLIC ::   ln_flx      = .FALSE.   !: flux      formulation
@@ -75,51 +83,43 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ssh_m     !: mean (nn_fsbc time-step) sea surface height                [m]
 
+   !! * Substitutions
+#  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-   !!======================================================================
+   !!----------------------------------------------------------------------
 CONTAINS
 
-   FUNCTION sbc_oce_alloc()
+   INTEGER FUNCTION sbc_oce_alloc()
       !!---------------------------------------------------------------------
-      !!                  ***  ROUTINE sbc_oce_alloc  ***
+      !!                  ***  FUNCTION sbc_oce_alloc  ***
       !!---------------------------------------------------------------------
-      USE in_out_manager, ONLY: ctl_warn
-      IMPLICIT none
-      INTEGER :: sbc_oce_alloc
-      ! Local variables
       INTEGER :: ierr(4)
       !!---------------------------------------------------------------------
-
       ierr(:) = 0
-
-      ALLOCATE(utau(jpi,jpj),    utau_b(jpi,jpj),                      &
-               vtau(jpi,jpj),    vtau_b(jpi,jpj),                      &
-               taum(jpi,jpj),    wndm(jpi,jpj)  , Stat=ierr(1)) 
-
-      ALLOCATE(qsr(jpi,jpj),     qns(jpi,jpj),    qns_b(jpi,jpj),      &
-               qsr_tot(jpi,jpj), qns_tot(jpi,jpj),                     &
-               emp(jpi,jpj),     emp_b(jpi,jpj),                       &
-               emps(jpi,jpj),    emps_b(jpi,jpj), emp_tot(jpi,jpj),    &
-               Stat=ierr(2))
-
-      ALLOCATE(rnf(jpi,jpj),          rnf_b(jpi,jpj),                       &
-               sbc_tsc(jpi,jpj,jpts), sbc_tsc_b(jpi,jpj,jpts),         &  
-               qsr_hc(jpi,jpj,jpk) ,  qsr_hc_b(jpi,jpj,jpk),  Stat=ierr(3))
-
-      ALLOCATE(tprecip(jpi,jpj),      sprecip(jpi,jpj), fr_i(jpi,jpj), &
+      !
+      ALLOCATE( utau(jpi,jpj) , utau_b(jpi,jpj) , taum(jpi,jpj) ,     &
+         &      vtau(jpi,jpj) , vtau_b(jpi,jpj) , wndm(jpi,jpj) , STAT=ierr(1) ) 
+         !
+      ALLOCATE( qns_tot(jpi,jpj) , qns   (jpi,jpj) , qns_b(jpi,jpj),      &
+         &      qsr_tot(jpi,jpj) , qsr   (jpi,jpj) ,                     &
+         &      emp    (jpi,jpj) , emp_b (jpi,jpj) ,                       &
+         &      emps   (jpi,jpj) , emps_b(jpi,jpj) , emp_tot(jpi,jpj) , STAT=ierr(2))
+         !
+      ALLOCATE( rnf  (jpi,jpj) , sbc_tsc  (jpi,jpj,jpts) , qsr_hc  (jpi,jpj,jpk) ,     &
+         &      rnf_b(jpi,jpj) , sbc_tsc_b(jpi,jpj,jpts) , qsr_hc_b(jpi,jpj,jpk) , STAT=ierr(3) )
+         !
+      ALLOCATE( tprecip(jpi,jpj) , sprecip(jpi,jpj) , fr_i(jpi,jpj) ,     &
 #if defined key_cpl_carbon_cycle
-               atm_co2(jpi,jpj),                                       &
+         &      atm_co2(jpi,jpj) ,                                        &
 #endif
-               ssu_m(jpi,jpj), ssv_m(jpi,jpj), sst_m(jpi,jpj),         &
-               sss_m(jpi,jpj), ssh_m(jpi,jpj), Stat=ierr(4))
-
-      sbc_oce_alloc = MAXVAL(ierr)
-
-      IF(sbc_oce_alloc > 0)THEN
-         CALL ctl_warn('sbc_oce_alloc: allocation of arrays failed.')
-      END IF
-
+         &      ssu_m  (jpi,jpj) , sst_m(jpi,jpj) ,                       &
+         &      ssv_m  (jpi,jpj) , sss_m  (jpi,jpj), ssh_m(jpi,jpj) , STAT=ierr(4) )
+         !
+      sbc_oce_alloc = MAXVAL( ierr )
+      IF( lk_mpp            )   CALL mpp_sum ( sbc_oce_alloc )
+      IF( sbc_oce_alloc > 0 )   CALL ctl_warn('sbc_oce_alloc: allocation of arrays failed')
+      !
    END FUNCTION sbc_oce_alloc
 
@@ -139,6 +139,4 @@
       REAL(wp) ::   ztx, zty, ztau, zcoef ! temporary variables
       INTEGER  ::   ji, jj                ! dummy indices
-      !! * Substitutions
-#  include "vectopt_loop_substitute.h90"
       !!---------------------------------------------------------------------
       zcoef = 0.5 / ( zrhoa * zcdrag ) 
@@ -154,6 +152,7 @@
       END DO
       CALL lbc_lnk( wndm(:,:) , 'T', 1. )
-
+      !
    END SUBROUTINE sbc_tau2wnd
 
+   !!======================================================================
 END MODULE sbc_oce
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcapr.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcapr.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcapr.F90	(revision 2620)
@@ -19,6 +19,6 @@
    USE in_out_manager  ! I/O manager
    USE lib_fortran     ! distribued memory computing library
-   USE iom
-   USE restart
+   USE iom             ! IOM library
+   USE restart         ! ocean restart
 
    IMPLICIT NONE
@@ -32,21 +32,20 @@
    LOGICAL, PUBLIC ::   ln_ref_apr = .FALSE.  !: ref. pressure: global mean Patm (F) or a constant (F)
 
-   REAL(wp), ALLOCATABLE, PUBLIC, DIMENSION(:,:) ::   ssh_ib    ! Inverse barometer now    sea surface height     [m]
-   REAL(wp), ALLOCATABLE, PUBLIC, DIMENSION(:,:) ::   ssh_ibb   ! Inverse barometer before sea surface height     [m]
-   REAL(wp), ALLOCATABLE, PUBLIC, DIMENSION(:,:) ::   apr       ! atmospheric pressure at kt                   [N/m2]
+   REAL(wp), ALLOCATABLE, SAVE, PUBLIC, DIMENSION(:,:) ::   ssh_ib    ! Inverse barometer now    sea surface height   [m]
+   REAL(wp), ALLOCATABLE, SAVE, PUBLIC, DIMENSION(:,:) ::   ssh_ibb   ! Inverse barometer before sea surface height   [m]
+   REAL(wp), ALLOCATABLE, SAVE, PUBLIC, DIMENSION(:,:) ::   apr       ! atmospheric pressure at kt                 [N/m2]
    
    REAL(wp) ::   rpref = 101000._wp   ! reference atmospheric pressure          [N/m2]
    REAL(wp) ::   tarea                ! whole domain mean masked ocean surface
    REAL(wp) ::   r1_grau              ! = 1.e0 / (grav * rau0)
-
    
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:)   ::   sf_apr   ! structure of input fields (file informations, fields read)
+   TYPE(FLD), ALLOCATABLE, SAVE, DIMENSION(:) ::   sf_apr   ! structure of input fields (file informations, fields read)
 
    !! * Substitutions
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010) 
-   !! $Id $
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011) 
+   !! $Id: $
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
@@ -91,7 +90,6 @@
          !
          ALLOCATE( sf_apr(1), STAT=ierror )           !* allocate and fill sf_sst (forcing structure) with sn_sst
-         IF( ierror > 0 ) THEN
-            CALL ctl_stop( 'sbc_apr: unable to allocate sf_apr structure' )   ;   RETURN
-         ENDIF
+         IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_apr: unable to allocate sf_apr structure' )
+         !
          CALL fld_fill( sf_apr, (/ sn_apr /), cn_dir, 'sbc_apr', 'Atmospheric pressure ', 'namsbc_apr' )
                                 ALLOCATE( sf_apr(1)%fnow(jpi,jpj,1)   )
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_clio.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_clio.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_clio.F90	(revision 2620)
@@ -43,5 +43,4 @@
    PUBLIC sbc_blk_clio        ! routine called by sbcmod.F90 
    PUBLIC blk_ice_clio        ! routine called by sbcice_lim.F90 
-   PUBLIC sbc_blk_clio_alloc  ! routine called by nemogcm.F90
 
    INTEGER , PARAMETER ::   jpfld   = 7           ! maximum number of files to read 
@@ -77,29 +76,14 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   stauc        ! cloud optical depth 
    
-   REAL(wp)  ::   zeps    = 1.e-20                ! constant values
-   REAL(wp)  ::   zeps0   = 1.e-13  
+   REAL(wp) ::   eps20  = 1.e-20   ! constant values
    
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
-
-   FUNCTION sbc_blk_clio_alloc()
-      !!---------------------------------------------------------------------
-      !!                 ***  ROUTINE sbc_blk_clio_alloc  ***
-      !!---------------------------------------------------------------------
-      IMPLICIT none
-      INTEGER :: sbc_blk_clio_alloc
-      !!---------------------------------------------------------------------
-
-      ALLOCATE(sbudyko(jpi,jpj), &
-               stauc(jpi,jpj),   &
-               Stat=sbc_blk_clio_alloc)
-
-   END FUNCTION sbc_blk_clio_alloc
 
    SUBROUTINE sbc_blk_clio( kt )
@@ -134,5 +118,5 @@
       !!
       INTEGER  ::   ifpr, jfpr         ! dummy indices
-      INTEGER  ::   ierror             ! return error code
+      INTEGER  ::   ierr0, ierr1, ierr2, ierr3   ! return error code
       !!
       CHARACTER(len=100) ::  cn_dir                            !   Root directory for location of CLIO files
@@ -171,14 +155,17 @@
          
          ! set sf structure
-         ALLOCATE( sf(jpfld), STAT=ierror )
-         IF( ierror > 0 ) THEN
-            CALL ctl_stop( 'sbc_blk_clio: unable to allocate sf structure' )   ;   RETURN
-         ENDIF
+         ALLOCATE( sf(jpfld), STAT=ierr0 )
+         IF( ierr0 > 0 )   CALL ctl_stop( 'STOP', 'sbc_blk_clio: unable to allocate sf structure' )
          DO ifpr= 1, jpfld
-            ALLOCATE( sf(ifpr)%fnow(jpi,jpj,1) )
-            IF( slf_i(ifpr)%ln_tint ) ALLOCATE( sf(ifpr)%fdta(jpi,jpj,1,2) )
-         END DO
+            ALLOCATE( sf(ifpr)%fnow(jpi,jpj,1) , STAT=ierr1)
+            IF( slf_i(ifpr)%ln_tint ) ALLOCATE( sf(ifpr)%fdta(jpi,jpj,1,2) , STAT=ierr2 )
+         END DO
+         IF( ierr1+ierr2 > 0 )   CALL ctl_stop( 'STOP', 'sbc_blk_clio: unable to allocate sf array structure' )
          ! fill sf with slf_i and control print
          CALL fld_fill( sf, slf_i, cn_dir, 'sbc_blk_clio', 'flux formulation for ocean surface boundary condition', 'namsbc_clio' )
+         
+         ! allocate sbcblk clio arrays
+         ALLOCATE( sbudyko(jpi,jpj) , stauc(jpi,jpj), STAT=ierr3 )
+         IF( ierr3 > 0 )   CALL ctl_stop( 'STOP', 'sbc_blk_clio: unable to allocate arrays' )
          !
       ENDIF
@@ -330,5 +317,5 @@
             zdeltaq = zqatm - zqsato
             ztvmoy  = ztatm * ( 1. + 2.2e-3 * ztatm * zqatm )
-            zdenum  = MAX( sf(jp_wndm)%fnow(ji,jj,1) * sf(jp_wndm)%fnow(ji,jj,1) * ztvmoy, zeps )
+            zdenum  = MAX( sf(jp_wndm)%fnow(ji,jj,1) * sf(jp_wndm)%fnow(ji,jj,1) * ztvmoy, eps20 )
             zdtetar = zdteta / zdenum
             ztvmoyr = ztvmoy * ztvmoy * zdeltaq / zdenum
@@ -352,5 +339,5 @@
             zpsil   = zpsih
             
-            zvatmg         = MAX( 0.032 * 1.5e-3 * sf(jp_wndm)%fnow(ji,jj,1) * sf(jp_wndm)%fnow(ji,jj,1) / grav, zeps )
+            zvatmg         = MAX( 0.032 * 1.5e-3 * sf(jp_wndm)%fnow(ji,jj,1) * sf(jp_wndm)%fnow(ji,jj,1) / grav, eps20 )
             zcmn           = vkarmn / LOG ( 10. / zvatmg )
             zchn           = 0.0327 * zcmn
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 2620)
@@ -78,5 +78,4 @@
    !!----------------------------------------------------------------------
 CONTAINS
-
 
    SUBROUTINE sbc_blk_core( kt )
@@ -167,10 +166,8 @@
          !
          ALLOCATE( sf(jfld), STAT=ierror )         ! set sf structure
-         IF( ierror > 0 ) THEN
-            CALL ctl_stop( 'sbc_blk_core: unable to allocate sf structure' )   ;   RETURN
-         ENDIF
+         IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_blk_core: unable to allocate sf structure' )
          DO ifpr= 1, jfld
             ALLOCATE( sf(ifpr)%fnow(jpi,jpj,1) )
-            IF( slf_i(ifpr)%ln_tint ) ALLOCATE( sf(ifpr)%fdta(jpi,jpj,1,2) )
+            IF( slf_i(ifpr)%ln_tint )   ALLOCATE( sf(ifpr)%fdta(jpi,jpj,1,2) )
          END DO
          !                                         ! fill sf with slf_i and control print
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 2620)
@@ -58,5 +58,4 @@
    PUBLIC   sbc_cpl_ice_tau    ! routine called by sbc_ice_lim(_2).F90
    PUBLIC   sbc_cpl_ice_flx    ! routine called by sbc_ice_lim(_2).F90
-   PUBLIC   sbc_cpl_init_alloc ! routine called by nemogcm.F90
 
    INTEGER, PARAMETER ::   jpr_otx1   =  1            ! 3 atmosphere-ocean stress components on grid 1
@@ -155,5 +154,5 @@
    INTEGER , ALLOCATABLE, SAVE, DIMENSION(    :) ::   nrcvinfo           ! OASIS info argument
 
-#if ! defined key_lim2 && ! defined key_lim3
+#if ! defined key_lim2   &&   ! defined key_lim3
    ! quick patch to be able to run the coupled model without sea-ice...
    INTEGER, PARAMETER               ::   jpl = 1 
@@ -173,34 +172,25 @@
 CONTAINS
   
-   FUNCTION sbc_cpl_init_alloc()
-      !!----------------------------------------------------------------------
-      !!             ***  ROUTINE sbc_cpl_init_alloc  ***
-      !!----------------------------------------------------------------------
-      IMPLICIT none
-      INTEGER :: sbc_cpl_init_alloc
+   INTEGER FUNCTION sbc_cpl_alloc()
+      !!----------------------------------------------------------------------
+      !!             ***  FUNCTION sbc_cpl_alloc  ***
+      !!----------------------------------------------------------------------
       INTEGER :: ierr(2)
       !!----------------------------------------------------------------------
-
       ierr(:) = 0
-
-      ALLOCATE(albedo_oce_mix(jpi,jpj), &
-               frcv(jpi,jpj,jprcv),     &
-               nrcvinfo(jprcv),  Stat=Stat=ierr(1))
-
+      !
+      ALLOCATE( albedo_oce_mix(jpi,jpj), frcv(jpi,jpj,jprcv), nrcvinfo(jprcv),  STAT=ierr(1) )
+      !
 #if ! defined key_lim2 && ! defined key_lim3
       ! quick patch to be able to run the coupled model without sea-ice...
-      ALLOCATE(hicif(jpi,jpj), hsnif(jpi,jpj), u_ice(jpi,jpj),  &
-               v_ice(jpi,jpj), fr1_i0(jpi,jpj),fr2_i0(jpi,jpj), &
-               tn_ice(jpi,jpj,jpl), alb_ice(jpi,jpj,jpl),       &
-               Stat=ierr(2) )
+      ALLOCATE( hicif(jpi,jpj) , u_ice(jpi,jpj) , fr1_i0(jpi,jpj) , tn_ice (jpi,jpj,jpl) ,     &
+                hsnif(jpi,jpj) , v_ice(jpi,jpj) , fr2_i0(jpi,jpj) , alb_ice(jpi,jpj,jpl) , STAT=ierr(2) )
 #endif
-
-      sbc_cpl_init_alloc = MAXVAL(ierr)
-
-      IF(sbc_cpl_init_alloc > 0)THEN
-         CALL ctl_warn('sbc_cpl_init_alloc: allocation of arrays failed.')
-      END IF
-
-    END FUNCTION sbc_cpl_init_alloc
+      sbc_cpl_init_alloc = MAXVAL( ierr )
+      IF( lk_mpp            )   CALL mpp_sum ( sbc_cpl_alloc )
+      IF( sbc_cpl_alloc > 0 )   CALL ctl_warn('sbc_cpl_alloc: allocation of arrays failed')
+      !
+   END FUNCTION sbc_cpl_alloc
+
 
    SUBROUTINE sbc_cpl_init( k_ice )     
@@ -233,7 +223,6 @@
       !!---------------------------------------------------------------------
 
-      IF(.not. wrk_use(2,1,2))THEN
-         CALL ctl_stop('sbc_cpl_init: requested workspace arrays unavailable.')
-         RETURN
+      IF(.NOT. wrk_use(2,1,2) ) THEN
+         CALL ctl_stop('sbc_cpl_init: requested workspace arrays unavailable.')   ;   RETURN
       END IF
 
@@ -273,5 +262,5 @@
 
 #if defined key_cpl_carbon_cycle 
-      REWIND( numnam )                    ! ... read namlist namsbc_cpl_co2
+      REWIND( numnam )                    ! read namlist namsbc_cpl_co2
       READ  ( numnam, namsbc_cpl_co2 )
       IF(lwp) THEN                        ! control print
@@ -291,4 +280,7 @@
       cn_rcv_tau(1) = TRIM( cn_rcv_tau_nature )   ;   cn_rcv_tau(2) = TRIM( cn_rcv_tau_refere )
       cn_rcv_tau(3) = TRIM( cn_rcv_tau_orient )   ;   cn_rcv_tau(4) = TRIM( cn_rcv_tau_grid   )
+
+      !                                   ! allocate zdfric arrays
+      IF( sbc_cpl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_cpl_alloc : unable to allocate arrays' )
      
       ! ================================ !
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcdcy.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcdcy.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcdcy.F90	(revision 2620)
@@ -21,10 +21,11 @@
    IMPLICIT NONE
    PRIVATE
-   INTEGER, PUBLIC              ::   nday_qsr                    ! day when parameters were computed
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   raa , rbb  , rcc  , rab     ! parameters used to compute the diurnal cycle
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   rtmd, rdawn, rdusk, rscal   !     -       -         -           -      -
+   
+   INTEGER, PUBLIC ::   nday_qsr   !: day when parameters were computed
+   
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   raa , rbb  , rcc  , rab     ! diurnal cycle parameters
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   rtmd, rdawn, rdusk, rscal   !    -      -       -
   
    PUBLIC   sbc_dcy        ! routine called by sbc
-   PUBLIC   sbc_dcy_alloc  ! routine called by nemogcm.F90
 
    !!----------------------------------------------------------------------
@@ -35,24 +36,19 @@
 CONTAINS
 
-      FUNCTION sbc_dcy_alloc()
+      INTEGER FUNCTION sbc_dcy_alloc()
          !!----------------------------------------------------------------------
-         !!                ***  ROUTINE sbc_dcy_alloc  ***
+         !!                ***  FUNCTION sbc_dcy_alloc  ***
          !!----------------------------------------------------------------------
-         IMPLICIT none
-         INTEGER :: sbc_dcy_alloc
-         !!----------------------------------------------------------------------
-
-         ALLOCATE(raa(jpi,jpj),  rbb(jpi,jpj),   rcc(jpi,jpj),   rab(jpi,jpj),   &
-                  rtmd(jpi,jpj), rdawn(jpi,jpj), rdusk(jpi,jpj), rscal(jpi,jpj), &
-                  Stat=sbc_dcy_alloc)
-
-         IF(sbc_dcy_alloc /= 0)THEN
-            CALL ctl_warn('sbc_dcy_alloc: failed to allocate arrays.')
-         END IF
-
+         !
+         ALLOCATE( raa (jpi,jpj) , rbb  (jpi,jpj) , rcc  (jpi,jpj) , rab  (jpi,jpj) ,     &
+            &      rtmd(jpi,jpj) , rdawn(jpi,jpj) , rdusk(jpi,jpj) , rscal(jpi,jpj) , STAT=sbc_dcy_alloc )
+            !
+         IF( lk_mpp             )   CALL mpp_sum ( sbc_dcy_alloc )
+         IF( sbc_dcy_alloc /= 0 )   CALL ctl_warn('sbc_dcy_alloc: failed to allocate arrays')
+         !
       END FUNCTION sbc_dcy_alloc
 
 
-      FUNCTION sbc_dcy( pqsrin ) RESULT( zqsrout )
+   FUNCTION sbc_dcy( pqsrin ) RESULT( zqsrout )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE sbc_dcy  ***
@@ -85,12 +81,11 @@
       ! Initialization
       ! --------------
-      ztwopi    = 2. * rpi
-      zinvtwopi = 1. / ztwopi
-      zconvrad  = ztwopi / 360.
+      ztwopi    = 2._wp * rpi
+      zinvtwopi = 1._wp / ztwopi
+      zconvrad  = ztwopi / 360._wp
 
       ! When are we during the day (from 0 to 1)
-      zlo = ( REAL(nsec_day, wp) - 0.5   * rdttra(1) ) / rday
-      zup = zlo + ( REAL(nn_fsbc, wp) * rdttra(1) ) / rday
-
+      zlo = ( REAL(nsec_day, wp) - 0.5_wp * rdttra(1) ) / rday
+      zup = zlo + ( REAL(nn_fsbc, wp)     * rdttra(1) ) / rday
       !                                          
       IF( nday_qsr == -1 ) THEN       ! first time step only               
@@ -101,4 +96,6 @@
             WRITE(numout,*)
          ENDIF
+         ! allocate sbcdcy arrays
+         IF( sbc_dcy_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_dcy_alloc : unable to allocate arrays' )
          ! Compute rcc needed to compute the time integral of the diurnal cycle
          rcc(:,:) = zconvrad * glamt(:,:) - rpi
@@ -156,6 +153,6 @@
              END DO  
          END DO  
-         rdawn(:,:) = MOD((rdawn(:,:) + 1.), 1.)
-         rdusk(:,:) = MOD((rdusk(:,:) + 1.), 1.)
+         rdawn(:,:) = MOD( (rdawn(:,:) + 1._wp), 1._wp )
+         rdusk(:,:) = MOD( (rdusk(:,:) + 1._wp), 1._wp )
 
          !     2.2 Compute the scalling function:
@@ -185,5 +182,5 @@
          ztmp = rday / ( rdttra(1) * REAL(nn_fsbc, wp) )
          rscal(:,:) = rscal(:,:) * ztmp
-
+         !
       ENDIF 
 
